diff --git a/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart b/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
index dbb9585..bd43001 100644
--- a/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
+++ b/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
@@ -13,6 +13,8 @@ import 'package:timeline_tile/timeline_tile.dart';
 import 'package:image_picker/image_picker.dart';
 import 'package:supabase_flutter/supabase_flutter.dart';
 import 'dart:io';
+import 'package:penyaluran_app/app/widgets/inputs/dropdown_input.dart';
+import 'package:penyaluran_app/app/widgets/inputs/text_input.dart';
 
 class DetailPengaduanView extends GetView<PengaduanController> {
   const DetailPengaduanView({Key? key}) : super(key: key);
@@ -111,12 +113,29 @@ class DetailPengaduanView extends GetView<PengaduanController> {
           return _buildDetailContent(context, pengaduan, tindakanList);
         },
       ),
-      floatingActionButton: FloatingActionButton(
-        onPressed: () {
-          _showTambahTindakanDialog(context, pengaduanId);
+      floatingActionButton: FutureBuilder<Map<String, dynamic>>(
+        future: controller.getDetailPengaduan(pengaduanId),
+        builder: (context, snapshot) {
+          if (!snapshot.hasData) return const SizedBox();
+
+          final data = snapshot.data;
+          if (data == null || data['pengaduan'] == null)
+            return const SizedBox();
+
+          final pengaduan = PengaduanModel.fromJson(data['pengaduan']);
+
+          if (pengaduan.status?.toUpperCase() == 'SELESAI') {
+            return const SizedBox();
+          }
+
+          return FloatingActionButton(
+            onPressed: () {
+              _showTambahTindakanDialog(context, pengaduanId);
+            },
+            backgroundColor: AppTheme.primaryColor,
+            child: const Icon(Icons.add, color: Colors.white),
+          );
         },
-        backgroundColor: AppTheme.primaryColor,
-        child: const Icon(Icons.add),
       ),
     );
   }
@@ -669,33 +688,77 @@ class DetailPengaduanView extends GetView<PengaduanController> {
     );
   }
 
-  void _showKonfirmasiSelesai(BuildContext context, String pengaduanId) {
-    showDialog(
-      context: context,
-      builder: (context) => AlertDialog(
-        title: const Text('Konfirmasi'),
-        content: const Text(
-          'Apakah Anda yakin ingin menyelesaikan pengaduan ini? Status pengaduan akan berubah menjadi SELESAI.',
-        ),
-        actions: [
-          TextButton(
-            onPressed: () => Navigator.pop(context),
-            child: const Text('Batal'),
+  void _showKonfirmasiSelesai(BuildContext context, String pengaduanId) async {
+    // Cek status tindakan
+    bool allTindakanSelesai = true;
+
+    try {
+      // Cek status tindakan dari Supabase
+      final tindakanList =
+          await SupabaseService.to.getTindakanPengaduan(pengaduanId);
+
+      if (tindakanList != null) {
+        allTindakanSelesai = tindakanList.every((t) {
+          return t['status_tindakan'] == 'SELESAI';
+        });
+      }
+
+      if (!allTindakanSelesai) {
+        Get.snackbar(
+          'Peringatan',
+          'Semua tindakan harus diselesaikan terlebih dahulu sebelum menyelesaikan pengaduan',
+          snackPosition: SnackPosition.TOP,
+          backgroundColor: Colors.orange,
+          colorText: Colors.white,
+        );
+        return;
+      }
+
+      showDialog(
+        context: context,
+        builder: (context) => AlertDialog(
+          title: const Text('Konfirmasi'),
+          content: const Text(
+            'Apakah Anda yakin ingin menyelesaikan pengaduan ini? Status pengaduan akan berubah menjadi SELESAI.',
           ),
-          ElevatedButton(
-            onPressed: () async {
-              await controller.selesaikanPengaduan(pengaduanId);
-              Navigator.pop(context);
-              Get.forceAppUpdate();
-            },
-            style: ElevatedButton.styleFrom(
-              backgroundColor: Colors.green,
+          actions: [
+            TextButton(
+              onPressed: () => Navigator.pop(context),
+              child: const Text('Batal'),
             ),
-            child: const Text('Ya, Selesaikan'),
-          ),
-        ],
-      ),
-    );
+            ElevatedButton(
+              onPressed: () async {
+                try {
+                  await controller.selesaikanPengaduan(pengaduanId);
+                  Navigator.pop(context);
+                  Get.forceAppUpdate();
+                } catch (e) {
+                  Get.snackbar(
+                    'Error',
+                    'Gagal menyelesaikan pengaduan: $e',
+                    snackPosition: SnackPosition.TOP,
+                    backgroundColor: Colors.red,
+                    colorText: Colors.white,
+                  );
+                }
+              },
+              style: ElevatedButton.styleFrom(
+                backgroundColor: Colors.green,
+              ),
+              child: const Text('Ya, Selesaikan'),
+            ),
+          ],
+        ),
+      );
+    } catch (e) {
+      Get.snackbar(
+        'Error',
+        'Gagal memeriksa status tindakan: $e',
+        snackPosition: SnackPosition.TOP,
+        backgroundColor: Colors.red,
+        colorText: Colors.white,
+      );
+    }
   }
 
   Widget _buildPengaduanInfo(BuildContext context, PengaduanModel pengaduan) {
@@ -780,10 +843,10 @@ class DetailPengaduanView extends GetView<PengaduanController> {
             const Divider(height: 24),
 
             // Informasi penyaluran
-            _buildInfoRow('Nama Penyaluran', pengaduan.namaPenyaluran ?? '-'),
-            _buildInfoRow('Jenis Bantuan', pengaduan.jenisBantuan ?? '-'),
-            _buildInfoRow('Jumlah Bantuan', pengaduan.jumlahBantuan ?? '-'),
-            _buildInfoRow('Deskripsi', pengaduan.deskripsiPenyaluran ?? '-'),
+            _buildInfoRow('Nama Penyaluran', pengaduan.namaPenyaluran),
+            _buildInfoRow('Jenis Bantuan', pengaduan.jenisBantuan),
+            _buildInfoRow('Jumlah Bantuan', pengaduan.jumlahBantuan),
+            _buildInfoRow('Deskripsi', pengaduan.deskripsiPenyaluran),
           ],
         ),
       ),
@@ -943,25 +1006,6 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                       backgroundColor: dotColor,
                       textColor: Colors.white,
                     ),
-                    const SizedBox(width: 8),
-                    // Tombol edit
-                    InkWell(
-                      onTap: () {
-                        _showEditTindakanDialog(context, tindakan);
-                      },
-                      child: Container(
-                        padding: const EdgeInsets.all(4),
-                        decoration: BoxDecoration(
-                          color: Colors.blue.withOpacity(0.1),
-                          borderRadius: BorderRadius.circular(4),
-                        ),
-                        child: const Icon(
-                          Icons.edit,
-                          size: 16,
-                          color: Colors.blue,
-                        ),
-                      ),
-                    ),
                   ],
                 ),
               ],
@@ -1042,9 +1086,9 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                   Text(
                     'Bukti Tindakan:',
                     style: TextStyle(
-                      fontSize: 12,
                       fontWeight: FontWeight.bold,
-                      color: Colors.grey.shade700,
+                      fontSize: 14,
+                      color: Colors.grey.shade800,
                     ),
                   ),
                   const SizedBox(height: 8),
@@ -1052,44 +1096,22 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                     scrollDirection: Axis.horizontal,
                     child: Row(
                       children: tindakan.buktiTindakan!.map((bukti) {
-                        return Container(
-                          width: 60,
-                          height: 60,
-                          margin: const EdgeInsets.only(right: 8),
-                          decoration: BoxDecoration(
-                            color: Colors.grey.shade200,
-                            borderRadius: BorderRadius.circular(4),
-                          ),
-                          child: Stack(
-                            children: [
-                              Center(
-                                child: Icon(
-                                  Icons.insert_drive_file,
-                                  color: Colors.blue.shade700,
-                                ),
+                        return GestureDetector(
+                          onTap: () => showFullScreenImage(context, bukti),
+                          child: Container(
+                            width: 80,
+                            height: 80,
+                            margin: const EdgeInsets.only(right: 8),
+                            decoration: BoxDecoration(
+                              color: Colors.grey.shade200,
+                              borderRadius: BorderRadius.circular(8),
+                              image: DecorationImage(
+                                image: bukti.startsWith('http')
+                                    ? NetworkImage(bukti)
+                                    : FileImage(File(bukti)) as ImageProvider,
+                                fit: BoxFit.cover,
                               ),
-                              Positioned(
-                                top: 0,
-                                right: 0,
-                                child: InkWell(
-                                  onTap: () {
-                                    tindakan.buktiTindakan!.remove(bukti);
-                                  },
-                                  child: Container(
-                                    padding: const EdgeInsets.all(2),
-                                    decoration: BoxDecoration(
-                                      color: Colors.red,
-                                      shape: BoxShape.circle,
-                                    ),
-                                    child: const Icon(
-                                      Icons.close,
-                                      color: Colors.white,
-                                      size: 14,
-                                    ),
-                                  ),
-                                ),
-                              ),
-                            ],
+                            ),
                           ),
                         );
                       }).toList(),
@@ -1195,6 +1217,43 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                 textColor: Colors.white,
               ),
             ],
+            // Tampilkan tombol edit jika status PROSES
+            if (tindakan.statusTindakan == 'PROSES') ...[
+              const SizedBox(height: 8),
+              //divider
+              Divider(
+                color: Colors.grey.shade400,
+                thickness: 1,
+              ),
+              TextButton.icon(
+                style: TextButton.styleFrom(
+                  padding: const EdgeInsets.symmetric(
+                    horizontal: 12,
+                    vertical: 8,
+                  ),
+                  shape: RoundedRectangleBorder(
+                    borderRadius: BorderRadius.circular(8),
+                    side: BorderSide(color: Colors.blue),
+                  ),
+                  minimumSize: Size(double.infinity, 36),
+                ),
+                onPressed: () {
+                  _showEditTindakanDialog(context, tindakan);
+                },
+                icon: Icon(
+                  Icons.update,
+                  size: 18,
+                  color: Colors.blue,
+                ),
+                label: Text(
+                  'Input Hasil Tindakan',
+                  style: TextStyle(
+                    color: Colors.blue,
+                    fontSize: 13,
+                  ),
+                ),
+              ),
+            ],
           ],
         ),
       ),
@@ -1217,13 +1276,9 @@ class DetailPengaduanView extends GetView<PengaduanController> {
   void _showTambahTindakanDialog(BuildContext context, String pengaduanId) {
     final formKey = GlobalKey<FormState>();
     final tindakanController = TextEditingController();
-    final catatanController = TextEditingController();
     String? selectedKategori;
     String? selectedPrioritas;
-
-    // Gunakan RxList untuk bukti tindakan
-    final buktiTindakanList = <String>[].obs;
-    final isUploading = false.obs;
+    String selectedStatus = 'PROSES';
 
     final List<String> kategoriOptions = [
       'VERIFIKASI_DATA',
@@ -1249,73 +1304,27 @@ class DetailPengaduanView extends GetView<PengaduanController> {
       'TINGGI',
     ];
 
-    // Fungsi untuk mengunggah bukti tindakan
-    Future<void> uploadBukti() async {
-      try {
-        isUploading.value = true;
+    // Konversi ke format DropdownItem
+    final List<DropdownItem<String>> kategoriItems = kategoriOptions
+        .map((kategori) => DropdownItem<String>(
+              value: kategori,
+              label: kategori.replaceAll('_', ' '),
+            ))
+        .toList();
 
-        // Buka image picker untuk memilih file
-        final ImagePicker picker = ImagePicker();
-        final XFile? pickedFile = await picker.pickImage(
-          source: ImageSource.gallery,
-          imageQuality: 70,
-        );
-
-        if (pickedFile == null) {
-          isUploading.value = false;
-          return;
-        }
-
-        // Upload file ke Supabase Storage
-        final String filePath = pickedFile.path;
-        final String fileName = filePath.split('/').last;
-        final String fileExt = fileName.split('.').last;
-        final String fileKey =
-            'bukti_tindakan_${DateTime.now().millisecondsSinceEpoch}.$fileExt';
-
-        // Upload ke bucket tindakan_pengaduan
-        await SupabaseService.to.client.storage
-            .from('tindakan_pengaduan')
-            .upload(
-              fileKey,
-              File(filePath),
-              fileOptions:
-                  const FileOptions(cacheControl: '3600', upsert: true),
-            );
-
-        // Dapatkan URL publik
-        final String fileUrl = SupabaseService.to.client.storage
-            .from('tindakan_pengaduan')
-            .getPublicUrl(fileKey);
-
-        // Tambahkan URL ke list bukti
-        buktiTindakanList.add(fileUrl);
-
-        Get.snackbar(
-          'Berhasil',
-          'Bukti berhasil diunggah',
-          snackPosition: SnackPosition.TOP,
-          backgroundColor: Colors.green,
-          colorText: Colors.white,
-        );
-      } catch (e) {
-        print('Error uploading bukti: $e');
-        Get.snackbar(
-          'Error',
-          'Gagal mengunggah bukti: ${e.toString()}',
-          snackPosition: SnackPosition.TOP,
-          backgroundColor: Colors.red,
-          colorText: Colors.white,
-        );
-      } finally {
-        isUploading.value = false;
-      }
-    }
+    // Konversi ke format DropdownItem untuk prioritas
+    final List<DropdownItem<String>> prioritasItems = prioritasOptions
+        .map((prioritas) => DropdownItem<String>(
+              value: prioritas,
+              label: prioritas[0].toUpperCase() +
+                  prioritas.substring(1).toLowerCase(),
+            ))
+        .toList();
 
     showDialog(
       context: context,
       builder: (context) => AlertDialog(
-        title: const Text('Tambah Tindakan'),
+        title: const Text('Tindakan Baru'),
         content: Form(
           key: formKey,
           child: SingleChildScrollView(
@@ -1323,29 +1332,16 @@ class DetailPengaduanView extends GetView<PengaduanController> {
               mainAxisSize: MainAxisSize.min,
               crossAxisAlignment: CrossAxisAlignment.start,
               children: [
-                DropdownButtonFormField<String>(
-                  decoration: const InputDecoration(
-                    labelText: 'Kategori Tindakan',
-                    border: OutlineInputBorder(),
-                  ),
+                // Kategori tindakan menggunakan DropdownInput
+                DropdownInput<String>(
+                  label: 'Kategori Tindakan',
+                  hint: 'Pilih kategori tindakan',
+                  items: kategoriItems,
                   value: selectedKategori,
-                  items: kategoriOptions.map((kategori) {
-                    return DropdownMenuItem<String>(
-                      value: kategori,
-                      child: Text(
-                        kategori
-                            .split('_')
-                            .map((word) =>
-                                word[0].toUpperCase() +
-                                word.substring(1).toLowerCase())
-                            .join(' '),
-                        style: const TextStyle(fontSize: 14),
-                      ),
-                    );
-                  }).toList(),
                   onChanged: (value) {
                     selectedKategori = value;
                   },
+                  required: true,
                   validator: (value) {
                     if (value == null || value.isEmpty) {
                       return 'Pilih kategori tindakan';
@@ -1353,26 +1349,19 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                     return null;
                   },
                 ),
+
                 const SizedBox(height: 16),
-                DropdownButtonFormField<String>(
-                  decoration: const InputDecoration(
-                    labelText: 'Prioritas',
-                    border: OutlineInputBorder(),
-                  ),
+
+                // Prioritas menggunakan DropdownInput
+                DropdownInput<String>(
+                  label: 'Prioritas',
+                  hint: 'Pilih prioritas tindakan',
+                  items: prioritasItems,
                   value: selectedPrioritas,
-                  items: prioritasOptions.map((prioritas) {
-                    return DropdownMenuItem<String>(
-                      value: prioritas,
-                      child: Text(
-                        prioritas[0].toUpperCase() +
-                            prioritas.substring(1).toLowerCase(),
-                        style: const TextStyle(fontSize: 14),
-                      ),
-                    );
-                  }).toList(),
                   onChanged: (value) {
                     selectedPrioritas = value;
                   },
+                  required: true,
                   validator: (value) {
                     if (value == null || value.isEmpty) {
                       return 'Pilih prioritas tindakan';
@@ -1380,14 +1369,16 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                     return null;
                   },
                 ),
+
                 const SizedBox(height: 16),
-                TextFormField(
+
+                // Deskripsi tindakan menggunakan TextInput
+                TextInput(
+                  label: 'Deskripsi Tindakan',
+                  hint: 'Masukkan deskripsi tindakan',
                   controller: tindakanController,
-                  decoration: const InputDecoration(
-                    labelText: 'Tindakan',
-                    border: OutlineInputBorder(),
-                  ),
-                  maxLines: 3,
+                  maxLines: 2,
+                  required: true,
                   validator: (value) {
                     if (value == null || value.isEmpty) {
                       return 'Tindakan tidak boleh kosong';
@@ -1395,125 +1386,6 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                     return null;
                   },
                 ),
-                const SizedBox(height: 16),
-                TextFormField(
-                  controller: catatanController,
-                  decoration: const InputDecoration(
-                    labelText: 'Catatan (opsional)',
-                    border: OutlineInputBorder(),
-                  ),
-                  maxLines: 2,
-                ),
-                const SizedBox(height: 16),
-                // Bukti tindakan
-                Column(
-                  crossAxisAlignment: CrossAxisAlignment.start,
-                  children: [
-                    Text(
-                      'Bukti Tindakan:',
-                      style: TextStyle(
-                        fontWeight: FontWeight.bold,
-                        fontSize: 14,
-                        color: Colors.grey.shade800,
-                      ),
-                    ),
-                    const SizedBox(height: 8),
-                    Container(
-                      padding: const EdgeInsets.all(12),
-                      decoration: BoxDecoration(
-                        color: Colors.grey.shade100,
-                        borderRadius: BorderRadius.circular(8),
-                        border: Border.all(color: Colors.grey.shade300),
-                      ),
-                      child: Column(
-                        crossAxisAlignment: CrossAxisAlignment.start,
-                        children: [
-                          Obx(() {
-                            if (buktiTindakanList.isEmpty) {
-                              return const Text(
-                                'Belum ada bukti tindakan',
-                                style: TextStyle(
-                                  fontStyle: FontStyle.italic,
-                                  color: Colors.grey,
-                                ),
-                              );
-                            } else {
-                              return Wrap(
-                                spacing: 8,
-                                runSpacing: 8,
-                                children: buktiTindakanList.map((bukti) {
-                                  return Container(
-                                    width: 80,
-                                    height: 80,
-                                    decoration: BoxDecoration(
-                                      color: Colors.grey.shade200,
-                                      borderRadius: BorderRadius.circular(8),
-                                    ),
-                                    child: Stack(
-                                      children: [
-                                        Center(
-                                          child: Icon(
-                                            Icons.insert_drive_file,
-                                            color: Colors.blue.shade700,
-                                            size: 36,
-                                          ),
-                                        ),
-                                        Positioned(
-                                          top: 0,
-                                          right: 0,
-                                          child: InkWell(
-                                            onTap: () {
-                                              buktiTindakanList.remove(bukti);
-                                            },
-                                            child: Container(
-                                              padding: const EdgeInsets.all(2),
-                                              decoration: BoxDecoration(
-                                                color: Colors.red,
-                                                shape: BoxShape.circle,
-                                              ),
-                                              child: const Icon(
-                                                Icons.close,
-                                                color: Colors.white,
-                                                size: 14,
-                                              ),
-                                            ),
-                                          ),
-                                        ),
-                                      ],
-                                    ),
-                                  );
-                                }).toList(),
-                              );
-                            }
-                          }),
-                          const SizedBox(height: 12),
-                          Obx(() => ElevatedButton.icon(
-                                onPressed:
-                                    isUploading.value ? null : uploadBukti,
-                                icon: isUploading.value
-                                    ? const SizedBox(
-                                        width: 16,
-                                        height: 16,
-                                        child: CircularProgressIndicator(
-                                          strokeWidth: 2,
-                                          color: Colors.white,
-                                        ),
-                                      )
-                                    : const Icon(Icons.upload_file),
-                                label: Text(isUploading.value
-                                    ? 'Mengunggah...'
-                                    : 'Tambah Bukti'),
-                                style: ElevatedButton.styleFrom(
-                                  backgroundColor: Colors.blue,
-                                  foregroundColor: Colors.white,
-                                  minimumSize: const Size(double.infinity, 40),
-                                ),
-                              )),
-                        ],
-                      ),
-                    ),
-                  ],
-                ),
               ],
             ),
           ),
@@ -1524,59 +1396,35 @@ class DetailPengaduanView extends GetView<PengaduanController> {
             child: const Text('Batal'),
           ),
           ElevatedButton(
-            onPressed: () async {
-              if (formKey.currentState!.validate()) {
-                try {
-                  // Buat objek tindakan
-                  final Map<String, dynamic> tindakanData = {
-                    'pengaduan_id': pengaduanId,
-                    'tindakan': tindakanController.text,
-                    'catatan': catatanController.text,
-                    'status_tindakan': 'PROSES',
-                    'prioritas': selectedPrioritas,
-                    'kategori_tindakan': selectedKategori,
-                    'tanggal_tindakan': DateTime.now().toIso8601String(),
-                    'petugas_id': controller.user?.id,
-                    'bukti_tindakan': buktiTindakanList.toList(),
-                    'created_at': DateTime.now().toIso8601String(),
-                    'updated_at': DateTime.now().toIso8601String(),
-                  };
-
-                  // Simpan tindakan langsung ke Supabase
-                  await SupabaseService.to
-                      .tambahTindakanPengaduan(tindakanData);
-
-                  // Update status pengaduan
-                  await SupabaseService.to
-                      .updateStatusPengaduan(pengaduanId, 'TINDAKAN');
-
-                  // Tutup dialog
-                  Navigator.pop(context);
-
-                  // Refresh halaman
-                  Get.forceAppUpdate();
-
-                  // Tampilkan snackbar
-                  Get.snackbar(
-                    'Berhasil',
-                    'Tindakan berhasil ditambahkan',
-                    snackPosition: SnackPosition.TOP,
-                    backgroundColor: Colors.green,
-                    colorText: Colors.white,
-                  );
-                } catch (e) {
-                  print('Error adding tindakan: $e');
-                  Get.snackbar(
-                    'Error',
-                    'Gagal menambahkan tindakan: ${e.toString()}',
-                    snackPosition: SnackPosition.TOP,
-                    backgroundColor: Colors.red,
-                    colorText: Colors.white,
-                  );
-                }
-              }
-            },
-            child: const Text('Simpan'),
+            onPressed: controller.isUploading.value
+                ? null
+                : () {
+                    if (formKey.currentState!.validate()) {
+                      controller.tambahTindakanPengaduan(
+                        pengaduanId: pengaduanId,
+                        tindakan: tindakanController.text,
+                        kategoriTindakan: selectedKategori ?? '',
+                        statusTindakan: selectedStatus,
+                        prioritas: selectedPrioritas ?? '',
+                        catatan: null,
+                        hasilTindakan: null,
+                        buktiTindakanPaths: [],
+                      );
+                    }
+                  },
+            style: ElevatedButton.styleFrom(
+              backgroundColor: AppTheme.primaryColor,
+            ),
+            child: controller.isUploading.value
+                ? const SizedBox(
+                    width: 20,
+                    height: 20,
+                    child: CircularProgressIndicator(
+                      strokeWidth: 2,
+                      color: Colors.white,
+                    ),
+                  )
+                : const Text('Simpan'),
           ),
         ],
       ),
